%ext ck1
%version 1.31

#tileinfo
%patchfile $130F8 mod.tli

#Keen only has to complete 1 level to win 
%patch $8020 $83 $BF $A6 $AA $00 $75 $1E $E8 $62 $01 $EB $29

# Make the door act like a wall when moving right 
%patch $2F31  $E8 $9D $E1 $90 $90 
# Make the door act like a wall when moving left 
%patch $2FE6  $E8 $0B $E1 $90 $90 

# Here's where the real work is done 
%patch $10D1  $81 $3E $54 $82 $C4 $45 $75 $15 
              $8B $87 $6E $05 $48 $48 $3D $04 
              $00 $73 $0A $89 $C3 $D1 $E3 $83 
              $BF $9E $AA $01 $C3 $83 $BF $86 
              $18 $00 $C3 $81 $3E $54 $82 $C4 
              $45 $75 $15 $8B $87 $6E $05 $48 
              $48 $3D $04 $00 $73 $0A $89 $C3 
              $D1 $E3 $83 $BF $9E $AA $01 $C3 
              $83 $BF $FA $0E $00 $C3 

# Stop the door bouncing 
%patch $43A4  $E9 $D1 $01


# leaves 227 spare bytes at CS:10D1 
# leaves 164 spare bytes at DS:1E02 ($14E52) 

# Patch in the long-integer drawing function 
%patch $11B4                   $55 $89 $E5 $B8 $0A $00 $50 $B8 $90 $82 $50 $FF 
               $76 $06 $FF $76 $04 $E8 $03 $C2 $83 $C4 $08 $B8 $90 $82 $50 $E8 
               $A5 $C5 $44 $44 $8B $56 $08 $29 $C2 $89 $16 $82 $82 $8B $46 $0A 
               $A3 $F8 $82 $B8 $90 $82 $50 $E8 $E8 $50 $44 $44 $89 $EC $5D $C3 

# Patch in the name of the status dialog text file 
%patch $13084  "STATUS.CK1" $00 

# Patch in the code to draw the status text (coordinates are measure in characters--8 pixel blocks) 
%patch $0E6A                                           $B8 $00 $3D $BA $34 $00   # Show status window (0E6A) 
               $CD $21 $89 $C3 $BF $27 $00 $C6 $06 $9A $82 $00 $B9 $0A $00 $BA 
               $90 $82 $B4 $3F $CD $21 $53 $B8 $90 $82 $50 $E8 $2E $97 $44 $44 
               $5B $4F $75 $E8 $B4 $3E $CD $21 
                                               $8B $46 $FE $05 $01 $00 $50 $89   # Show score (0E98) 
               $F0 $05 $0A $00 $50 $FF $36 $CC $AA $FF $36 $CA $AA $E8 $04 $03 
               $83 $C4 $08 
                           $8B $46 $FE $05 $01 $00 $50 $89 $F0 $05 $1A $00 $50   # Show extra Keen score (0EB3) 
               $A1 $C4 $6E $8B $16 $C2 $6E $81 $C2 $20 $4E $15 $00 $00 $50 $52 
               $E8 $E1 $02 $83 $C4 $08 
                                       $31 $FF $3B $3E $C6 $AA $7D $29 $83 $FF   # Show Keens (0ED6) 
               $06 $7D $24 $B8 $00 $00 $50 $8B $46 $FE $05 $03 $00 $B1 $03 $D3 
               $E0 $90 $90 $50 $89 $F8 $D1 $E0 $05 $01 $00 $01 $F0 $50 $E8 $2C 
               $AC $83 $C4 $06 $47 $EB $D1 
%patch $0F07                               $B8 $90 $00 $83 $3E $94 $AA $00 $74   # Draw the joystick 
               $03 $B8 $C0 $01 $50 $8B $46 $FE $05 $03 $00 $B1 $03 $D3 $E0 $05 
               $04 $00 $50 $89 $F0 $05 $10 $00 $50 $E8 $0D $AA $83 $C4 $06 
                                                                           $B8   # Draw the battery 
               $90 $00 $83 $3E $9C $AA $00 $74 $03 $B8 $C1 $01 $50 $8B $46 $FE 
               $05 $03 $00 $B1 $03 $D3 $E0 $05 $04 $00 $50 $89 $F0 $05 $13 $00 
               $50 $E8 $E5 $A9 $83 $C4 $06 
                                           $B8 $90 $00 $83 $3E $96 $AA $00 $74   # Draw the vacuum 
               $03 $B8 $C2 $01 $50 $8B $46 $FE $05 $03 $00 $B1 $03 $D3 $E0 $05 
               $04 $00 $50 $89 $F0 $05 $16 $00 $50 $E8 $BD $A9 $83 $C4 $06 
                                                                           $B8   # Draw the whiskey 
               $90 $00 $83 $3E $98 $AA $00 $74 $03 $B8 $C3 $01 $50 $8B $46 $FE 
               $05 $03 $00 $B1 $03 $D3 $E0 $05 $04 $00 $50 $89 $F0 $05 $19 $00 
               $50 $E8 $95 $A9 $83 $C4 $06 
%patch $0FA7                               $B8 $90 $00 $83 $3E $9E $AA $00 $74   # Keycard A 
               $03 $B8 $A8 $01 $50 $8B $46 $FE $05 $07 $00 $B1 $03 $D3 $E0 $05 
               $04 $00 $50 $89 $F0 $05 $13 $00 $50 $E8 $6D $A9 $83 $C4 $06 
                                                                           $B8   # Keycard B 
               $90 $00 $83 $3E $A0 $AA $00 $74 $03 $B8 $A9 $01 $50 $8B $46 $FE 
               $05 $07 $00 $B1 $03 $D3 $E0 $05 $04 $00 $50 $89 $F0 $05 $17 $00 
               $50 $E8 $45 $A9 $83 $C4 $06 
                                           $B8 $90 $00 $83 $3E $A2 $AA $00 $74   # Keycard C 
               $03 $B8 $AA $01 $50 $8B $46 $FE $05 $09 $00 $B1 $03 $D3 $E0 $05 
               $04 $00 $50 $89 $F0 $05 $13 $00 $50 $E8 $1D $A9 $83 $C4 $06 
                                                                           $B8   # Keycard D 
               $90 $00 $83 $3E $A4 $AA $00 $74 $03 $B8 $AB $01 $50 $8B $46 $FE 
               $05 $09 $00 $B1 $03 $D3 $E0 $05 $04 $00 $50 $89 $F0 $05 $17 $00 
               $50 $E8 $F5 $A8 $83 $C4 $06 
%patch $1047                               $B8 $90 $00 $83 $3E $9A $AA $00 $74   # Pogo stick 
               $03 $B8 $9F $01 $50 $8B $46 $FE $05 $08 $00 $B1 $03 $D3 $E0 $05 
               $04 $00 $50 $89 $F0 $05 $0B $00 $50 $E8 $CD $A8 $83 $C4 $06 
                                                                           $8B   # Draw ammo 
               $46 $FE $05 $0B $00 $50 $89 $F0 $05 $06 $00 $50 $31 $C0 $50 $FF 
               $36 $C8 $AA $E8 $2E $01 $83 $C4 $08 
                                                   $B8 $9E $01 $50 $8B $46 $FE   # Draw raygun (replace first two bytes 
               $05 $07 $00 $B1 $03 $D3 $E0 $05 $04 $00 $50 $89 $F0 $05 $03 $00   # with $EB $1C if you don't want to 
               $50 $E8 $95 $A8 $83 $C4 $06                                       # draw the raygun on the status screen) 

                                           $E8 $90 $4B $31 $C0 $50 $E8 $1E $AD   # Wait for a key, then return 
               $44 $44 $E8 $81 $A6 $E8 $D1 $F1 $E8 $CE $F1 $E8 $7C $4B $8B $46 
               $FC $8B $56 $FA $89 $16 $35 $51 $A3 $37 $51 $5F $5E $89 $EC $5D 
               $C3 

# Change the teleporter so it works within the level (updated 24/09/03) 
%patch $8919                           $89 $F0 $F7 $2E $08 $6C $01 
   $F8 $D1 $E0 $C4 $1E $4C $6C $01 $C3 $26 $8B $07 $50 $88 $E0 $98 
   $99 $01 $F0 $83 $D2 $00 $B1 $0C $E8 $16 $58 $89 $16 $E4 $6E $A3 
   $E2 $6E $05 $00 $B0 $83 $D2 $FF $A3 $D4 $6E $89 $16 $D6 $6E $58 
   $98 $99 $01 $F8 $83 $D2 $00 $B1 $0C $E8 $F5 $57 $89 $16 $E0 $6E 
   $A3 $DE $6E $05 $00 $70 $83 $D2 $FF $A3 $D0 $6E $89 $16 $D2 $6E 
   $C3 
%patch $4572  $E8 $A4 $43 $EB $13 $90 



# fix exit
%patch $414E $90
%patch $412A $90
%patch $4137 $90
%patch $4161 $90
#%patch $4176 $35 $00
#%patch $41A0 $1C $00


%level.hint 2
Thanks for finding
the jetpack. Sorry
for making you get
it, but the maze was
too dangerous. We'll
take if off your
hands now.

#joystick takes pogo
%patch $4446 $C7 $06 $9A $AA $00 $00

#joystick disappears to gray
%patch $455E $8F $00

#################
#### SPRITES ####
#################

# Keen jetpacks, but much easier to control 
%patch $3F4E $90 $90 

# don't bounce when pogo hits ground
%patch $3FB6 $67 $38

# keen jumps higher
%patch $3BAC $07 $00

# keen pogos lower
%patch $3F40 $40 $00

# yorp movement
%patch $18D4 $80 $FF # [si+20] left speed
%patch $18CD $80 $00 # [si+20] right speed
%patch $19C2 $80 $FF # [si+20] left speed
%patch $19CE $80 $00 # [si+20] right speed
%patch $1964 $00 $03 # [si+22] yorps jump higher when this is higher
%patch $1A1C $80 $FF # [si+20] left speed
%patch $1A14 $80 $00 # [si+20] right speed

# garg still charges
%patch $1B8B $00 

# dead vort turns into yorp
%patch $1D8D $90 $90 $90 $90 $90 $90 $90 $90 $90
%patch $1DAF $90 $90 $90 $90 $90 $90 $90 $90 $90 $90
             $90 $90 $90 $90 $90 $90 $90 $90 $90 $90
%patch $1DAD $4F $19
%patch $1DA8 $68 $1A
%patch $1DA3 $30 $00
%patch $1D98 $00 $02 $00

# vort moves faster
%patch $1C8C $00 $FF           # MOV [0x8240],word 0xFF88
%patch $1C94 $50 $FF           # MOV [0x8240],word 0xFFA6
%patch $1C9C $00 $01           # MOV [0x8240],word 0x0078
%patch $1CA4 $B0 $00           # MOV [0x8240],word 0x005A
%patch $1CB7 $50 $FF           # MOV [0x8240],word 0xFFA6
%patch $1CC3 $B0 $00           # MOV [0x8240],word 0x005A
%patch $1D04 $50 $FF           # MOV [0x8240],word 0xFFA6
%patch $1D10 $B0 $00           # MOV [0x8240],word 0x005A
%patch $1D41 $B0 $00           # MOV [0x8240],word 0x005A

# vort jumps higher
%patch $1C49 $80 $02           # MOV AX,word 0x012C - [si+22]

# Strength of vorticon (1 less than # shots) 
%patch $180D  $02 $00

#robot's shots kill Keen but not other enemies
%patch $48E9 $04 $00


################
#### CHEATS ####
################

# Set Keen's pogo to zero (take Keen's pogo). Use $01 if you want it to give Keen pogo. 
%patch $0DFD $00

%patch 0x014DEE "You just cheated.    "
%patch 0x014E05 "Don't think you're going  "
%patch 0x014E21 "to get a jetpack this " 
%patch 0x014E39 "way!                    "

%patch 0x014EF6 "Invincibility!  "
%patch 0x014F07 "No Invincibility!"

# C7069AAA0100

################
#### FINALE ####
################

# Keen sprite at finale 
%patch $81F1 $1E $00 # This is sprite $28 = 40 (Map keen facing left)
# Map top-left corner coords (multiplied by $1000) 
%patch $81D6 $00 $40
%patch $81DC $00 $80
%patch $81E2 $00 $00    
%patch $81E8 $00 $00
#Refocus sprite
%patch $81E0 $90

#Finale
%patch 0x015C24 "Norp the Yorp finds himself being  "
%patch 0x015C49 "drawn by an unknown force from   "
%patch 0x015C6C "the dreaded labyrinth. Hopefully   "
%patch 0x015C91 "this is the end of the maze.   "

# First dialogue box at home
%patch 0x015CBD "Norp finds himself    "
%patch 0x015CD5 "back in the       "
%patch 0x015CE9 "holding cell.    "

%patch 0x015CFB "Unable to keep his "
%patch 0x015D10 "eyes open, he falls"
%patch 0x015D25 "asleep.   "

%patch 0x015D30 "The lights flick on--"
#Text jump
%patch 0x015D47 "DON'T TURN THE LIGHTS"
%patch 0x015D5E "ON I'M TRYING TO   "
%patch 0x015D73 "SLEEP!!!!!!"

%patch 0x015D80 "Geez, calm down,"
%patch 0x015D92 "sorry... "

%patch 0x015D9C "You better be.        "
%patch 0x015DB4 "You capture me      "
%patch 0x015DCA "and then send me on..  "

%patch 0x015DE2 "some bug hunt for a"

%patch 0x015DF6 "freakin jetpack!"

%patch 0x015E07 "It was an important  "
%patch 0x015E1E "heirloom for us. Here's"
%patch 0x015E37 "some money and     "
%patch 0x015E4C "anytime you need a   "
%patch 0x015E63 "favor, call us"


#######################
#### APOGEE SCREEN ####
#######################

# drop certain bmps
%patch $A1FD $90 $90 $90 #an
%patch $A224 $90 $90 $90 #presentation
%patch $A25A $90 $90 $90 #production
%patch $A248 $90 $90 $90 #id software

# 'of an' bitmap
%patch $A22B $01 $00

#'Apogee rises at
%patch $A1E0 $04 $00
#'Apogee' x position
%patch $A20C $04 $00
#Appearing Apogee bitmap
%patch $A204 $09 $00


########################
#### MENU AND ITEMS ####
########################

# TITLE POSITION
%patch $97B2   $00 $00     # Y location, in pixels 
%patch $97B6   $04 $00     # (X location in pixels) / 8 + 4

# menu
%patch 0x015EE8 "Play!    "
%patch 0x015EF5 "Load Game     "
%patch 0x015F07 "Story "
%patch 0x015F11 "About xtra.."
%patch 0x015F21 "The Keenest "
%patch 0x015F31 "Keen Modding  "
%patch 0x015F43 "Old Norps "
%patch 0x015F51 "Title screen  "
%patch 0x015F61 "        "
%patch 0x015F6A "      "

# About ID...
%patch 0x015F80 "xtraverse is a Commander Keen fan "
%patch 0x015FA8 "who loves modding the original   "
%patch 0x015FD0 "games.                        "
%patch 0x015FF8 "                    "
%patch 0x016020 "Currently he's working on       "
%patch 0x016048 "the Norp the Yorp series,          "
%patch 0x016070 "of which this is the      "
%patch 0x016098 "fourth installment.    "
%patch 0x0160C0 "Visit xtraverse's Keen       "
%patch 0x0160E8 "website, Beyond the Pogo,        "
%patch 0x016110 "at http://spatang.com/ck "

# High score items
%patch $992A $C0 $01   
%patch $995D $C1 $01   
%patch $9990 $C2 $01    
%patch $99C3 $C3 $01  

# Highscores animation offset disable
%patch $9929 $B8
%patch $995C $B8
%patch $998F $B8
%patch $99C2 $B8

# Ordering Info
%patch 0x01632C "Commander Keen: Modding "
%patch 0x016346 "Using the excellent tools"
%patch 0x016364 "by adurdin, one can"
%patch 0x01637B "    mod all seven    "
%patch 0x016392 "    episodes of Keen.    "
%patch 0x0163AD "  Download all of these  "
%patch 0x0163C8 "tools at Beyond the Pogo "
%patch 0x0163E4 "       (http://spatang.com/ck)       "
%patch 0x01640D "    Check out other great mods,   " $0A $00 "       like Xky Rauh's great series." $0A $00 "        (Episodes X, Null, and Dash)   "  $0A $00 "                                            "

#Check out spatang...stolen from Xky
%patch 0x000164b3 " Visit us online:"
%patch 0x000164c4 0x0A 0x00
%patch 0x000164c6 "(a 56k or cable          Lots of mods,"
%patch 0x000164ec 0x0A 0x00
%patch 0x000164ee " modem both work        utilities and "
%patch 0x00016514 0x0A 0x00
%patch 0x00016516 " just as well.)         fun downloads!  "
%patch 0x0001653e 0x0A 0x0A 0x0A 0x00
%patch 0x00016542 "http://www.spatang.com/ck  for all your "
%patch 0x0001656a 0x0A 0x00
%patch 0x0001656b "  Commander Keen needs--Check it out!     "
%patch 0x00016599 0x0A 0x00

%end